/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 330
#ifdef HAVE_CONFIG_H
#line 330
# include <config.h>
#line 330
#endif
#line 330
#include <sys/types.h>
#line 330

#line 330
#include "mailfromd.h"
#line 330
#include "prog.h"
#line 330
#include "builtin.h"
#line 330

#line 330

#line 660 "../../src/builtin/snarf.m4"

#line 1 "dns.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include "srvcfg.h"

static size_t max_ptr = 64;
static size_t max_a = 64;
static size_t max_mx = MAXMXCOUNT;
static struct mu_cfg_param dns_cfg_param[] = {
	{ "max-dns-reply-a", mu_cfg_size, &max_a, 0, NULL,
	  N_("Maximum number of A records in a DNS reply.") },
	{ "max-dns-reply-ptr", mu_cfg_size, &max_a, 0, NULL,
	  N_("Maximum number of PTR records in a DNS reply.") },
	{ "max-dns-reply-mx", mu_cfg_size, &max_mx, 0, NULL,
	  N_("Maximum number of MX records in a DNS reply.") },
	{ NULL }
};


void
#line 37
bi_primitive_hostname(eval_environ_t env)
#line 37

#line 37 "dns.bi"
{
#line 37
	
#line 37

#line 37

#line 37
char * string;
#line 37
        
#line 37
get_string_arg(env, 0, &string);
#line 37
        
#line 37

#line 37
        adjust_stack(env, 1);
#line 37

#line 37
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 37
		prog_trace(env, "primitive_hostname %s",string);;
#line 37

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 43
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_hostname", _("cannot resolve IP %s"),string)
#line 46
;
	
	pushs(env, hbuf);
	free(hbuf);
}
}

void
#line 53
bi_primitive_resolve(eval_environ_t env)
#line 53

#line 53 "dns.bi"
{
#line 53
	
#line 53

#line 53
long __bi_argcnt;
#line 53
char * string;
#line 53
        char * domain;
#line 53
        
#line 53
get_string_arg(env, 1, &string);
#line 53
        get_string_arg(env, 2, &domain);
#line 53
        
#line 53
get_numeric_arg(env, 0, &__bi_argcnt);
#line 53
        adjust_stack(env, __bi_argcnt + 1);
#line 53

#line 53
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 53
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 53

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 60
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s.%s"),string,domain)
#line 62
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 65
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s"),string)
#line 67
;
	}
	pushs(env, ipstr);
	free(ipstr);
}
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 86
bi_dns_getaddr(eval_environ_t env)
#line 86

#line 86 "dns.bi"
{
#line 86
	
#line 86

#line 86

#line 86
char * string;
#line 86
        
#line 86
get_string_arg(env, 0, &string);
#line 86
        
#line 86

#line 86
        adjust_stack(env, 1);
#line 86

#line 86
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 86
		prog_trace(env, "dns_getaddr %s",string);;
#line 86

{
	GACOPYZ_UINT32_T *ipbuf;
	size_t i, ipcount;
	unsigned long ttl;
	dns_status dnstat;

	ipbuf = xcalloc(max_a, sizeof(ipbuf[0]));
	dnstat = a_lookup(string, ipbuf, max_a, &ipcount,
			  &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(ipbuf, ipcount, sizeof ipbuf[0], ipaddr_cmp);
		for (i = 0; i < ipcount; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = ipbuf[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 108
do {
#line 108
  char *__s = q;
#line 108
  heap_obstack_grow(env, __s, strlen(__s));
#line 108
} while (0);
		}
		free(ipbuf);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 112
do {
#line 112
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 112
  return;
#line 112
} while (0);
	}
	case dns_not_found:
		free(ipbuf);
		do {pushs(env, "");
#line 116
return;
#line 116
} while (0);
	default:
		free(ipbuf);
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getaddr", _("failed to get A record for %s"),string);
#line 121
	}
}
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 131
bi_dns_getname(eval_environ_t env)
#line 131

#line 131 "dns.bi"
{
#line 131
	
#line 131

#line 131

#line 131
char * ipstr;
#line 131
        
#line 131
get_string_arg(env, 0, &ipstr);
#line 131
        
#line 131

#line 131
        adjust_stack(env, 1);
#line 131

#line 131
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 131
		prog_trace(env, "dns_getname %s",ipstr);;
#line 131

{
	dns_status dnstat;
	struct in_addr addr;
	unsigned long ttl;
	char **names;

		if (!(inet_aton(ipstr, &addr)))
#line 138
			env_throw_bi(env, mfe_invip, "dns_getname", _("invalid IP: %s"),ipstr)
#line 140
;

	names = xcalloc(max_ptr, sizeof(names[0]));
	dnstat = ptr_lookup(addr, names, max_ptr, &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t i;
		size_t ncount;

		for (ncount = 0; ncount < max_ptr && names[ncount];
		     ncount++);
		
		qsort(names, ncount, sizeof names[0], hostname_cmp);

		heap_obstack_begin(env);
		for (i = 0; i < ncount; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 158
do {
#line 158
  char *__s = names[i];
#line 158
  heap_obstack_grow(env, __s, strlen(__s));
#line 158
} while (0);
		}
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		for (; i < ncount; i++) 
			free(names[i]);
		free(names);
		
#line 165
do {
#line 165
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 165
  return;
#line 165
} while (0);
	}
	case dns_not_found:
		free(names);
		do {pushs(env, "");
#line 169
return;
#line 169
} while (0);
	default:
		free(names);
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getname", _("failed to get PTR record for %s"),ipstr);
#line 174
	}
}
}

void
#line 178
bi_primitive_hasmx(eval_environ_t env)
#line 178

#line 178 "dns.bi"
{
#line 178
	
#line 178

#line 178

#line 178
char * string;
#line 178
        
#line 178
get_string_arg(env, 0, &string);
#line 178
        
#line 178

#line 178
        adjust_stack(env, 1);
#line 178

#line 178
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 178
		prog_trace(env, "primitive_hasmx %s",string);;
#line 178

{
	struct mxbuf mxbuf;
	mf_status mxstat;

	mxbuf.mx_flags = 0;
	mxstat = getmx(string, &mxbuf);
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 186
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_hasmx", _("cannot get MX records for %s"),string)
#line 189
;
	mxbuf_free(&mxbuf);
	if (mxstat == mf_success) {
		
#line 192
do {
#line 192
  push(env, (STKVAL) (1));
#line 192
  return;
#line 192
} while (0);
	}
	
#line 194
do {
#line 194
  push(env, (STKVAL) (0));
#line 194
  return;
#line 194
} while (0);
}
}

void
#line 198
bi_getmx(eval_environ_t env)
#line 198

#line 198 "dns.bi"
{
#line 198
	
#line 198

#line 198
long __bi_argcnt;
#line 198
char * domain;
#line 198
        long  no_resolve;
#line 198
        
#line 198
get_string_arg(env, 1, &domain);
#line 198
        get_numeric_arg(env, 2, &no_resolve);
#line 198
        
#line 198
get_numeric_arg(env, 0, &__bi_argcnt);
#line 198
        adjust_stack(env, __bi_argcnt + 1);
#line 198

#line 198
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 198
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? no_resolve : 0));;
#line 198

{
	mf_status mxstat;

	if (((__bi_argcnt > 1) ? no_resolve : 0)) {
		GACOPYZ_UINT32_T *ipbuf;
		size_t ipcount;

		ipbuf = xcalloc(max_mx, sizeof(ipbuf[0]));
		mxstat = getmxip(domain, ipbuf, max_mx, &ipcount);
		if (!mf_resolved(mxstat)) {
			free(ipbuf);
				env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain);
#line 212
		}
		if (mxstat == mf_not_found) {
			free(ipbuf);
			do {pushs(env, "");
#line 215
return;
#line 215
} while (0);
		} else {
			int i;
			
			heap_obstack_begin(env);
			for (i = 0; i < ipcount; i++) {
				struct in_addr s;
				s.s_addr = htonl(ipbuf[i]);
				
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 226
do {
#line 226
  char *__s = inet_ntoa(s);
#line 226
  heap_obstack_grow(env, __s, strlen(__s));
#line 226
} while (0);
			}
			free(ipbuf);
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 230
do {
#line 230
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 230
  return;
#line 230
} while (0);
		}
	} else {
		struct mxbuf mxbuf;

		mxbuf.mx_max = max_mx;
		mxbuf.mx_flags = MXF_MAX;
		mxstat = getmx(domain, &mxbuf);
		if (!mf_resolved(mxstat)) {
			mxbuf_free(&mxbuf);
				env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain);
#line 242
		}
		if (mxstat == mf_not_found) {
			mxbuf_free(&mxbuf);
			do {pushs(env, "");
#line 245
return;
#line 245
} while (0);
		} else {
			int i;
		
			heap_obstack_begin(env);
			for (i = 0; i < mxbuf.mx_cnt; i++) {
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 253
do {
#line 253
  char *__s = mxbuf.mx_buf[i];
#line 253
  heap_obstack_grow(env, __s, strlen(__s));
#line 253
} while (0);
			}
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			mxbuf_free(&mxbuf);
			
#line 257
do {
#line 257
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 257
  return;
#line 257
} while (0);
		}
	}
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error(_("INTERNAL ERROR at %s:%d: resolve_hostname returned "
			   "invalid IP address: %s"),
			 __FILE__, __LINE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 290
bi_primitive_ismx(eval_environ_t env)
#line 290

#line 290 "dns.bi"
{
#line 290
	
#line 290

#line 290

#line 290
char * domain;
#line 290
        char * ipstr;
#line 290
        
#line 290
get_string_arg(env, 0, &domain);
#line 290
        get_string_arg(env, 1, &ipstr);
#line 290
        
#line 290

#line 290
        adjust_stack(env, 2);
#line 290

#line 290
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 290
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 290

{
	GACOPYZ_UINT32_T *ipbuf;
	size_t ipcount;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	int i;
	
		if (!(resolve_host(ipstr, &ip) == 0))
#line 299
			env_throw_bi(env, mfe_noresolve, "primitive_ismx", _("cannot resolve host name %s"),ipstr)
;
	ip = ntohl(ip);

	ipbuf = xcalloc(max_mx, sizeof(ipbuf[0]));
	mxstat = getmxip(domain, ipbuf, max_mx, &ipcount);

	if (mxstat != mf_success) {
		free(ipbuf);
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_ismx", _("cannot get MXs for %s"),domain);
#line 310
	}

	for (i = 0; i < ipcount; i++) {
		if (ipbuf[i] == ip) {
			rc = 1;
			break;
		}
	}
		
	free(ipbuf);
	
#line 320
do {
#line 320
  push(env, (STKVAL) (rc));
#line 320
  return;
#line 320
} while (0);
}
}

void
#line 324
bi_relayed(eval_environ_t env)
#line 324

#line 324 "dns.bi"
{
#line 324
	
#line 324

#line 324

#line 324
char * s;
#line 324
        
#line 324
get_string_arg(env, 0, &s);
#line 324
        
#line 324

#line 324
        adjust_stack(env, 1);
#line 324

#line 324
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 324
		prog_trace(env, "relayed %s",s);;
#line 324

{
	
#line 326
do {
#line 326
  push(env, (STKVAL) (relayed_domain_p(s)));
#line 326
  return;
#line 326
} while (0);
}
}


#line 330
void
#line 330
dns_init_builtin()
#line 330
{
#line 330
	
#line 330
	#line 37 "dns.bi"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 53 "dns.bi"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_string);
#line 86 "dns.bi"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 131 "dns.bi"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 178 "dns.bi"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 198 "dns.bi"
va_builtin_install_ex("getmx", bi_getmx, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_number);
#line 290 "dns.bi"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_string);
#line 324 "dns.bi"
va_builtin_install_ex("relayed", bi_relayed, 0, dtype_number, 1, 0, 0|0, dtype_string);

#line 330 "dns.bi"
	
#line 330
	 mf_add_runtime_params(dns_cfg_param);
#line 330
	 
#line 330
}
#line 330 "dns.bi"

#line 332

#line 654 "../../src/builtin/snarf.m4"

#line 654

